Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## fr.gouv.culture.sdx.thesaurus
Class AbstractThesaurus

    java.lang.Object
      fr.gouv.culture.sdx.utils.AbstractSdxObject
          fr.gouv.culture.sdx.utils.database.DatabaseBacked
              fr.gouv.culture.sdx.documentbase.AbstractDocumentBase
                  fr.gouv.culture.sdx.documentbase.SDXDocumentBase
                      fr.gouv.culture.sdx.thesaurus.AbstractThesaurus

All Implemented Interfaces:
  org.apache.avalon.framework.configuration.Configurable, org.apache.avalon.framework.context.Contextualizable, Describable, DocumentBase, Encodable, Identifiable, Localizable, org.apache.avalon.framework.logger.LogEnabled, Saveable, SDXDocumentBaseTarget, SdxObject, SDXThesaurus, Searchable, org.apache.avalon.framework.service.Serviceable, Target, Thesaurus, org.apache.excalibur.xml.sax.XMLizable

public abstract class AbstractThesaurus
extends SDXDocumentBase
implements SDXThesaurus

Nested Class Summary

Nested classes inherited from class fr.gouv.culture.sdx.thesaurus.SDXThesaurus
`SDXThesaurus.ConfigurationNode`

Nested classes inherited from class fr.gouv.culture.sdx.documentbase.SDXDocumentBaseTarget
`SDXDocumentBaseTarget.ConfigurationNode`

Field Summary
`protected int` | `defaultDepth`
`protected int[]` | `defaultRelations`
`protected org.apache.excalibur.source.impl.URLSource` | `source`

Fields inherited from class fr.gouv.culture.sdx.documentbase.SDXDocumentBase
`_configuration, _documentAdditionStatus, _ilevel, _ilogger, _isIndexOptimized, autoOptimize, baseIndexDir, DOC_ADD_STATUS_ADDED, DOC_ADD_STATUS_FAILURE, DOC_ADD_STATUS_IGNORED, DOC_ADD_STATUS_REFRESHED, DOC_ADD_STATUS_REPLACED, DOC_URL, ELEMENT_NAME_DEFAULT_HPP, ELEMENT_NAME_DEFAULT_MAXSORT, isDatadirShared, keepOriginalDocuments, scheduler, SDX_DATABASE_FORMAT, SDX_DATABASE_VERSION, SDX_DATABASE_VERSION_2_3, SDX_DATE, SDX_DATE_MILLISECONDS, SDX_ISO8601_DATE, SDX_USER, splitActive, splitDoc, splitSize, splitUnit, useCompoundFiles`

Fields inherited from class fr.gouv.culture.sdx.documentbase.AbstractDocumentBase
`_indexationPipeline, _oaiHarv, ATTRIBUTE_AUTO_OPTIMIZE, ATTRIBUTE_COMPOUND_FILES, ATTRIBUTE_SPLIT_DOC, ATTRIBUTE_SPLIT_SIZE, ATTRIBUTE_SPLIT_UNIT, DBELEM_ATTRIBUTE_DEFAULT, DBELEM_ATTRIBUTE_HPP, DBELEM_ATTRIBUTE_KEEP_ORIGINAL, DBELEM_ATTRIBUTE_MAXSORT, defaultHitsPerPage, defaultMaxSort, defaultRepository, ELEMENT_NAME_INDEX_SPLIT, ELEMENT_NAME_OPTIMIZE, INTERNAL_FIELD_NAME_SDX_OAI_DELETED_RECORD, INTERNAL_FIELD_NAME_SDXALL, INTERNAL_FIELD_NAME_SDXAPPID, INTERNAL_FIELD_NAME_SDXCONTENTLENGTH, INTERNAL_FIELD_NAME_SDXDBID, INTERNAL_FIELD_NAME_SDXDOCID, INTERNAL_FIELD_NAME_SDXDOCTYPE, INTERNAL_FIELD_NAME_SDXMODDATE, INTERNAL_FIELD_NAME_SDXREPOID, INTERNAL_SDXALL_FIELD_VALUE, isDefault, locale, oaiRepo, oaiRepositories, PROPERTY_NAME_ATTACHED, PROPERTY_NAME_CONTENT_LENGTH, PROPERTY_NAME_DOCTYPE, PROPERTY_NAME_MIMETYPE, PROPERTY_NAME_ORIGINAL, PROPERTY_NAME_PARENT, PROPERTY_NAME_REPO, PROPERTY_NAME_SUB, repoConnectionPool, repositories, useMetadata`

Fields inherited from class fr.gouv.culture.sdx.utils.database.DatabaseBacked
`_database, CLASS_NAME_SUFFIX, DATABASE_DIR_NAME, databaseConf, dbLocation, dbPath, DEFAULT_DATABASE_TYPE`

Fields inherited from class fr.gouv.culture.sdx.utils.AbstractSdxObject
`_context, _description, _encoding, _id, _locale, _logger, _manager, _xmlizable_objects, _xmlLang, isToSaxInitialized`

Fields inherited from interface fr.gouv.culture.sdx.thesaurus.SDXThesaurus
`CLASS_NAME_SUFFIX, PACKAGE_QUALNAME`

Fields inherited from interface fr.gouv.culture.sdx.thesaurus.Thesaurus
`NAMESPACE_PREFIX, NAMESPACE_URI, RELATION_BROADER_TERM, RELATION_BROADER_TERMS, RELATION_EQUIVALENT_TERM, RELATION_NARROWER_TERM, RELATION_PARTIAL_EQIUVALENCE, RELATION_RELATED_TERM, RELATION_SCOPE_NOTE, RELATION_USE, RELATION_USED_FOR`

Fields inherited from interface fr.gouv.culture.sdx.utils.Encodable
`DEFAULT_ENCODING`

Fields inherited from interface fr.gouv.culture.sdx.utils.save.Saveable
`ALL_SAVE_ATTRIB, PATH_ATTRIB, SAVE_DIRECTORY_PARAM`

Constructor Summary
`AbstractThesaurus()`

Method Summary
`void` | `addConcept(Concept concept)` Adds a document.
`void` | `addConcepts(Concept[] concepts)` Adds a group of documents.
`void` | `configure(org.apache.avalon.framework.configuration.Configuration configuration)` Configures SDX document base
`protected void` | `configureBase(org.apache.avalon.framework.configuration.Configuration configuration)` Overrides parent method and allows for configuration element <sdx:thesaurus> set's the path for the this thesaurus/document base
`void` | `deleteConcept(Concept concept)` Removes a concept document with the given id and any sub concepts.
`void` | `deleteConcepts(Concept[] concepts)` Removes a concept document with the given id and any sub concepts.
`Concept[]` | `filterByLangs(Concept[] concepts, java.lang.String[] langs)` Filters concepts by a list of languages
`int` | `getDefaultDepth()` Return's the default depth for searching relations
`int[]` | `getDefaultRelations()` Return's the default set of relation int's for searching relations
`java.lang.String` | `getRelationTypeAbbreviation(int type)` Returns an abbreviation String for a relation type defined in the thesaurus
`int` | `getRelationTypeInt(java.lang.String abbr)` Returns an int for a relation type String defined in the thesaurus
`protected org.apache.avalon.framework.configuration.Configuration[]` | `getRepositoryConfigurationList(org.apache.avalon.framework.configuration.Configuration configuration)` Configures repositories

Methods inherited from class fr.gouv.culture.sdx.documentbase.SDXDocumentBase
`add, addToSearchIndex, backup, backupIndexes, backupTimeStamp, checkIntegrity, compactSearchIndex, configureDocumentBase, configureIdGenerator, configureOAIComponents, configureOAIHarvester, configureOAIRepositories, configureOAIRepository, configureOptimizeTriggers, configureRepositories, configureSplit, delete, delete, deleteFromSearchIndex, deleteIndexableDocumentComponents, deleteRelationsToMastersFromDatabase, getByteSplitSize, getConfiguration, getDocument, getDocument, getDocument, getDocument, getIndexationDocument, getIndexationInformations, getIndexationLogger, getOwners, getRelated, getRepositoryForDocument, getRepositoryForStorage, getSplitDoc, getSplitSize, getSplitUnit, getUseCompoundFiles, getXMLFieldList, handleParameters, index, index, index, indexModified, init, initToSax, initVolatileObjectsToSax, isAutoOptimized, isIndexOptimized, mergeBatch, mergeCurrentBatch, optimize, restore, restoreIndexes, restoreTimeStamp, rollbackIndexation, setBaseParameters, setConfiguration, splitCheck, splitIndex, targetTriggered`

Methods inherited from class fr.gouv.culture.sdx.documentbase.AbstractDocumentBase
`addOaiDeletedRecord, addOAIRepository, configurePipeline, createEntityForDocMetaData, createOAIRepository, createOAIRepository, delete, deletePhysicalDocument, getDefaultHitsPerPage, getDefaultMaxSort, getDefaultOAIRepository, getDefaultRepository, getIdGenerator, getIndexationPipeline, getMimeType, getOAIHarvester, getOAIRepositoriesSize, getOAIRepository, getOAIRepository, getPooledRepositoryConnection, getRepository, getSourceValidity, isDefault, isUseMetadata, managedOaiDeletedRecord, optimizeDatabase, optimizeRepositories, releasePooledRepositoryConnections, removeOaiDeletedRecord`

Methods inherited from class fr.gouv.culture.sdx.utils.database.DatabaseBacked
`configure, getClassNameSuffix, getDatabase`

Methods inherited from class fr.gouv.culture.sdx.utils.AbstractSdxObject
`configureDescription, contextualize, enableLogging, getBaseAttributes, getContext, getDescription, getEncoding, getId, getLocale, getLog, getServiceManager, getXmlLang, service, setDescription, setEncoding, setId, setLocale, setUpSdxObject, setUpSdxObject, setXmlLang, toSAX, verifyConfigurationResources`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface fr.gouv.culture.sdx.thesaurus.SDXThesaurus
`build, build, expandQuery, expandQuery, expandQuery, expandQuery, expandQuery, getConceptById, getConceptByName, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, getRelations, init, load, save, search, size, unload`

Methods inherited from interface fr.gouv.culture.sdx.thesaurus.Thesaurus
`compile`

Methods inherited from interface org.apache.excalibur.xml.sax.XMLizable
`toSAX`

Methods inherited from interface fr.gouv.culture.sdx.documentbase.DocumentBase
`checkIntegrity, createOAIRepository, creationDate, delete, delete, getDefaultHitsPerPage, getDefaultMaxSort, getDefaultRepository, getDocument, getDocument, getDocument, getDocument, getIndexationPipeline, getMimeType, getOAIHarvester, getOAIRepositoriesSize, getOAIRepository, getOAIRepository, getRepository, getSourceValidity, index, index, isDefault, lastModificationDate, optimize`

Methods inherited from interface fr.gouv.culture.sdx.utils.SdxObject
`getLog`

Methods inherited from interface org.apache.avalon.framework.logger.LogEnabled
`enableLogging`

Methods inherited from interface org.apache.avalon.framework.context.Contextualizable
`contextualize`

Methods inherited from interface org.apache.avalon.framework.service.Serviceable
`service`

Methods inherited from interface fr.gouv.culture.sdx.utils.Identifiable
`getId, setId`

Methods inherited from interface fr.gouv.culture.sdx.utils.Describable
`getDescription, setDescription`

Methods inherited from interface fr.gouv.culture.sdx.utils.Encodable
`getEncoding, setEncoding`

Methods inherited from interface fr.gouv.culture.sdx.utils.Localizable
`getLocale, getXmlLang, setLocale, setXmlLang`

Methods inherited from interface fr.gouv.culture.sdx.search.Searchable
`getId, getIndex`

Methods inherited from interface fr.gouv.culture.sdx.utils.save.Saveable
`backup, restore`

Field Detail

### defaultDepth

    protected int defaultDepth

### defaultRelations

    protected int[] defaultRelations

### source

    protected org.apache.excalibur.source.impl.URLSource source

Constructor Detail

### AbstractThesaurus

    public AbstractThesaurus()

Method Detail

### configure

    public void configure(org.apache.avalon.framework.configuration.Configuration configuration)
                   throws org.apache.avalon.framework.configuration.ConfigurationException

  Description copied from class: `SDXDocumentBase`
  Configures SDX document base

  Specified by:
    `configure` in interface `org.apache.avalon.framework.configuration.Configurable`
  Overrides:
    `configure` in class `SDXDocumentBase`
  Throws:
    `org.apache.avalon.framework.configuration.ConfigurationException`

### configureBase

    protected void configureBase(org.apache.avalon.framework.configuration.Configuration configuration)
                          throws org.apache.avalon.framework.configuration.ConfigurationException

  Overrides parent method and allows for configuration element <sdx:thesaurus> set's the path for the this thesaurus/document base

  Overrides:
    `configureBase` in class `SDXDocumentBase`
  Parameters:
    `configuration` -
  Throws:
    `org.apache.avalon.framework.configuration.ConfigurationException`

### getRepositoryConfigurationList

    protected org.apache.avalon.framework.configuration.Configuration[] getRepositoryConfigurationList(org.apache.avalon.framework.configuration.Configuration configuration)
                                                                                                throws org.apache.avalon.framework.configuration.ConfigurationException

  Description copied from class: `SDXDocumentBase`
  Configures repositories

  Overrides:
    `getRepositoryConfigurationList` in class `SDXDocumentBase`
  Parameters:
    `configuration` -
  Returns:
  Throws:
    `org.apache.avalon.framework.configuration.ConfigurationException`

### getRelationTypeAbbreviation

    public java.lang.String getRelationTypeAbbreviation(int type)

  Description copied from interface: `Thesaurus`
  Returns an abbreviation String for a relation type defined in the thesaurus

  Specified by:
    `getRelationTypeAbbreviation` in interface `Thesaurus`

### getRelationTypeInt

    public int getRelationTypeInt(java.lang.String abbr)

  Description copied from interface: `Thesaurus`
  Returns an int for a relation type String defined in the thesaurus

  Specified by:
    `getRelationTypeInt` in interface `Thesaurus`

### addConcept

    public void addConcept(Concept concept)
                    throws SDXException

  Adds a document.

  Specified by:
    `addConcept` in interface `SDXThesaurus`
  Parameters:
    `concept` - The document to add.
  Throws:
    `SDXException`

### addConcepts

    public void addConcepts(Concept[] concepts)
                     throws SDXException

  Description copied from interface: `SDXThesaurus`
  Adds a group of documents.

  Specified by:
    `addConcepts` in interface `SDXThesaurus`
  Parameters:
    `concepts` - The documents to add.
  Throws:
    `SDXException`

### deleteConcept

    public void deleteConcept(Concept concept)
                       throws SDXException

  Removes a concept document with the given id and any sub concepts.

  Specified by:
    `deleteConcept` in interface `SDXThesaurus`
  Parameters:
    `concept` - The document.
  Throws:
    `SDXException`

### deleteConcepts

    public void deleteConcepts(Concept[] concepts)
                        throws SDXException

  Removes a concept document with the given id and any sub concepts.

  Specified by:
    `deleteConcepts` in interface `SDXThesaurus`
  Parameters:
    `concepts` - The documents.
  Throws:
    `SDXException`

### filterByLangs

    public Concept[] filterByLangs(Concept[] concepts,
                                   java.lang.String[] langs)

  Description copied from interface: `SDXThesaurus`
  Filters concepts by a list of languages

  Specified by:
    `filterByLangs` in interface `SDXThesaurus`
  Parameters:
    `concepts` - List of concepts for filtering
    `langs` - List of langauages (in xml:lang format) which are desired
  Returns:

### getDefaultDepth

    public int getDefaultDepth()

  Description copied from interface: `SDXThesaurus`
  Return's the default depth for searching relations

  Specified by:
    `getDefaultDepth` in interface `SDXThesaurus`

### getDefaultRelations

    public int[] getDefaultRelations()

  Description copied from interface: `SDXThesaurus`
  Return's the default set of relation int's for searching relations

  Specified by:
    `getDefaultRelations` in interface `SDXThesaurus`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 Ministere de la culture et de la communication / AJLSM. All Rights Reserved.